/*
	========================================================
						Tardis  v1.0
	========================================================
	(c) 2005 by Lutz Schubert
	thanks to Uwe for helping me render the Tardis :)
	
	"Doctor Who" and the "Tardis" are trademarks of the BBC
	Please visit http://www.bbc.co.uk/doctorwho
						
							== * ==
	
	This program is free for distribution, any commercial
	use is strcitly prohibited. All images are copyright-
	protected and may not be distributed independently of
	this software without explicit permission by the author.
	
	The author takes no liability for any damages caused
	by usage of this program. No warranty is given.
	
	========================================================
	refer to Tardis.kon for version history
*/
var light1counter;
var light1steps = 6;
var light2counter;
var light2steps = 12;	// identical -> just once?
var lightAnimation;

		// rotate the TARDIS  ("tardisRotate")
		function rotate()
		{
			if (this.pause==true) {return true;}
			
			tardis_curimg += 1;
			if (tardis_curimg > tardis_imgs) { tardis_curimg=1; }
			imgTardisBody.src ="Tardis/TardisFull"+tardis_curimg+".png";
			return true;
		}

		// animate the background ("tunnelAnimation")
		function swirl()
		{
			if (this.pause==true) {return true;}	// paused animation
			
			if (preferences.rotation.value==1)
			{
				imgTunnel.rotation = (imgTunnel.rotation + Number(preferences.rotationspeed.value)) % 360;
			}
			
			if (preferences.colourize.value==1)
			{
				imgTunnel.hslAdjustment = "" + swirl_hue + "," + swirl_sat + "," + swirl_lig;
				swirl_hue += swirl_hued;
				if (swirl_hue >=  180) {swirl_hue=-180;} //swirl_hued=-swirl_hued;}
				//swirl_sat += swirl_satd;
				swirl_lig += swirl_ligd;
				if (swirl_lig >=  35) {swirl_ligd=-swirl_ligd;}
				if (swirl_lig <=  -35) {swirl_ligd=-swirl_ligd;}
			}
			
			return true;
		}

		// blink headlight ("blinkingLight")
		// this function is triggered by the main headlight animation
		function blink()
		{
			if (this.pause==true) { return true; }
			
			print("blink");
			this.pause=true;
			light1counter = 0;
			lightAnimation = new CustomAnimation( 100, light ); 
			animator.start(lightAnimation);
			return true;
		}
		
		// actually lighten up
		function light()
		{
			var mult = Math.sin( 3.1416* light1counter/light1steps );	// first half of a sine wave
		
			imgLightBehind.width = hind_max * mult;
			imgLightBehind.height = imgLightBehind.width;
			imgLightBehind.hRegistrationPoint = imgLightBehind.width/2;
			imgLightBehind.vRegistrationPoint = imgLightBehind.height/2;
			imgLightBehind.opacity = 255 * mult;

		if (preferences.lighttype.value>=2)
		{
			imgLightBlend.width  = blend_max/3;		// set only once
			imgLightBlend.height = blend_max * mult;
			imgLightBlend.hRegistrationPoint = imgLightBlend.width/2;
			imgLightBlend.vRegistrationPoint = imgLightBlend.height/2;
			imgLightBlend.opacity = 255 * mult;
		}
		
		if (preferences.lighttype.value>=3)
		{
			imgLightRing.width = light_max * mult;
			imgLightRing.height = imgLightRing.width;
			imgLightRing.hRegistrationPoint = imgLightRing.width/2;
			imgLightRing.vRegistrationPoint = imgLightRing.height/2;
			imgLightRing.opacity = 255 * mult;
		}

		if (light1counter>=light1steps) 
		{ 
			blinkingLight.pause = false;
			return false; 
		}

		light1counter++;
		return true;
	}
		
		// lighten headlight during materialisation
		//--------------------------------------------------
		function matlight()
		{
			var mult = Math.sin( 3.1416* light2counter/light2steps );	// first half of a sine wave
		
			imgLightBehind2.width = hind2_max * mult;
			imgLightBehind2.height = imgLightBehind2.width;
			imgLightBehind2.hRegistrationPoint = imgLightBehind2.width/2;
			imgLightBehind2.vRegistrationPoint = imgLightBehind2.height/2;
			imgLightBehind2.opacity = 255 * mult;

		if (preferences.lighttype.value>=2)
		{
			//imgLightBlend2.width  = blend2_max/2.5;		// set only once
			imgLightBlend2.height = blend2_max * mult;
			imgLightBlend2.hRegistrationPoint = imgLightBlend2.width/2;
			imgLightBlend2.vRegistrationPoint = imgLightBlend2.height/2;
			imgLightBlend2.opacity = 255 * mult;
		}
		
		if (preferences.lighttype.value>=3)
		{
			imgLightRing2.width = light2_max * mult*mult;
			imgLightRing2.height = imgLightRing2.width;
			imgLightRing2.hRegistrationPoint = imgLightRing2.width/2;
			imgLightRing2.vRegistrationPoint = imgLightRing2.height/2;
			imgLightRing2.opacity = 255 * mult;
		}
			if (light2counter>=light2steps) 
			{ 
				return false; 
			}

			light2counter++;
			return true;
		}

// initialise the widget
// covering reactions to preference changes
function init()
{
	// Tunnel Preferences
	if (preferences.visibility.value==1)
	{
		imgTunnel.opacity = 255;
		if ((preferences.rotation.value==0) && (preferences.colourize.value==0))
		{
			tunnelAnimation.pause = true;
		}
		else
		{
			tunnelAnimation.interval = Number( 100 * (11-preferences.rotationtimer.value) );
			tunnelAnimation.pause = false;
//			animator.start( tunnelAnimation );
		}
	}
	else
	{
		imgTunnel.opacity = 0;
//		tunnelAnimation.kill();
		tunnelAnimation.pause = true;
	}

	// Headlight preferences
	if (preferences.light.value==1) 
	{	
		blinkingLight.pause = false;
		blinkingLight.interval = Number ( 1000 * (16-preferences.lightfreq.value) ) + 50;
		print(blinkingLight.interval);
	}
	else
	{
		blinkingLight.pause = true;
		imgLightRing.opacity = 0;
		imgLightBehind.opacity = 0;
	}
	
	tardisRotate.pause = false;
}

// UPDATE GRAPHIC: weisser Kreis auf rotem Hintergund, bergangsmaske.... blend
// similar for background etc.!

// QUESTION: how to avoid performance problems from a hidden window?
// --> kill all animations,
//      re-init with showing the window again
//      (alternatively delay interval infinitely)